<template>
  <div id="imageupload">
    <picture-input
      ref="pictureInput"
      @change="onPictureChange"
      :width="250"
      :height="250"
      :radius="10"
      :accept="'image/jpeg,image/png'"
      :size="20"
      :buttonClass="'btn btn-primary'"
      :customStrings="customStrings">
    </picture-input>
  </div>
  <table v-if="predictions.length" class="table table-striped table-bordered">
      <thead>
        <tr>
          <th>{{ $t('message.class') }}</th>
          <th>{{ $t('message.score') }}</th>
          <th v-if="enriched">{{ $t('message.information') }}</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(prediction, index) in predictions.slice(0,5)" :key="index">
          <td>{{ prediction.class }}</td>
          <td>{{ (prediction.prediction * 100).toFixed(2) }}%</td>
          <td v-if="enriched">
            <div v-for="(enrichment, source) in prediction.enrichments" :key="source">
              <a :href=enrichment.url target="_blank">{{ $t(`source.${source}`) }}</a>
            </div>
          </td>
        </tr>
      </tbody>
  </table>
  <div v-if="isError" class="alert alert-danger" role="alert">
      {{ $t(message) }}
  </div>
  <div v-if="uploading" class="alert alert-info" role="alert">
      {{ $t('message.identify') }}
  </div>
</template>

<script>
import PictureInput from 'vue-picture-input';

export default {
  components: {
    PictureInput
  },
  data() {
    return {
      predictions: [],
      isError: false,
      enriched: false,
      message: '',
    };
  },
  computed: {
      customStrings() {
          return {
              drag: 'Upload',
              browse: 'Upload',
              noDrag: 'Upload',
              change: 'Upload'
          };
      }
  },
  methods: {
    onPictureChange(image) {
      if (image) {
        let formData = new FormData();
        formData.append('image', this.$refs.pictureInput.file);
        this.predictions = [];
        this.isError = false;
        this.uploading = true;

        let url = window.location.href;
        axios.post(url, formData, {
          headers: {
            'Content-Type': 'multipart/form-data'
          }
        })
        .then(response => {
            this.uploading = false;
            if (response.data && response.data.predictions && response.data.predictions.length) {
                this.predictions = response.data.predictions;
                this.enriched = response.data.enriched;
                this.isError = false;
            } else if (response.data && response.data.error) {
                this.predictions = [];
                this.isError = true;
                this.message = response.data.error;
            } else {
                this.predictions = [];
                this.isError = true;
                this.message = $t('message.noPredictions');
            }
        })
        .catch(error => {
            this.uploading = false;
            this.isError = true;
            this.message = $t('message.error');
        });
      }
    }
  }
};
</script>
